<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: GPIO.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">GPIO.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * GPIO.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Feb 28, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_GPIO_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_GPIO_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;driver/gpio.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span>ESP32CPP {</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classESP32CPP_1_1GPIO.html">   31</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classESP32CPP_1_1GPIO.html">GPIO</a> {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#adf4319c3ae87b69012c0c4696dc69081">addISRHandler</a>(gpio_num_t pin, gpio_isr_t handler, <span class="keywordtype">void</span>* pArgs);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#a9c168a825e68fa07f9d707c5832230f0">high</a>(gpio_num_t pin);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#a977756d253f25761e2412d8c191fe7da">interruptDisable</a>(gpio_num_t pin);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#a65c96a8cba32614babdc86c0eab9bd12">interruptEnable</a>(gpio_num_t pin);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classESP32CPP_1_1GPIO.html#ae715e46a8c6d0ba0ebe3d15de9cc7db0">inRange</a>(gpio_num_t pin);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#a83984b2c70af70005b39071ea88fb45c">low</a>(gpio_num_t pin);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classESP32CPP_1_1GPIO.html#add68250ce86665c502405a353ef1c870">read</a>(gpio_num_t pin);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#afd43e7bc27885215900f7780197a0247">setInput</a>(gpio_num_t pin);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#af649387f8f64c1abdc66d3b93c2e966b">setInterruptType</a>(gpio_num_t pin, gpio_int_type_t intrType);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#ac1599d926502a487e0e7518dc343a833">setOutput</a>(gpio_num_t pin);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#a6ed6d7b43b7eb1b8ec5b3cb192a58598">write</a>(gpio_num_t pin, <span class="keywordtype">bool</span> value);</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classESP32CPP_1_1GPIO.html#ad2538618676a072e7b80778df97e3341">writeByte</a>(gpio_num_t pins[], uint8_t value, <span class="keywordtype">int</span> bits);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    }; <span class="comment">// End GPIO</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;} <span class="comment">// End ESP32CPP namespace</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_GPIO_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classESP32CPP_1_1GPIO_html_ac1599d926502a487e0e7518dc343a833"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#ac1599d926502a487e0e7518dc343a833">ESP32CPP::GPIO::setOutput</a></div><div class="ttdeci">static void setOutput(gpio_num_t pin)</div><div class="ttdoc">Set the pin as output.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:167</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_a65c96a8cba32614babdc86c0eab9bd12"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#a65c96a8cba32614babdc86c0eab9bd12">ESP32CPP::GPIO::interruptEnable</a></div><div class="ttdeci">static void interruptEnable(gpio_num_t pin)</div><div class="ttdoc">Enable interrupts on the named pin.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:91</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_a6ed6d7b43b7eb1b8ec5b3cb192a58598"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#a6ed6d7b43b7eb1b8ec5b3cb192a58598">ESP32CPP::GPIO::write</a></div><div class="ttdeci">static void write(gpio_num_t pin, bool value)</div><div class="ttdoc">Write a value to the given pin.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:180</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_af649387f8f64c1abdc66d3b93c2e966b"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#af649387f8f64c1abdc66d3b93c2e966b">ESP32CPP::GPIO::setInterruptType</a></div><div class="ttdeci">static void setInterruptType(gpio_num_t pin, gpio_int_type_t intrType)</div><div class="ttdoc">Set the interrupt type. The type of interrupt can be one of:</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:151</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_a83984b2c70af70005b39071ea88fb45c"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#a83984b2c70af70005b39071ea88fb45c">ESP32CPP::GPIO::low</a></div><div class="ttdeci">static void low(gpio_num_t pin)</div><div class="ttdoc">Set the pin low.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:107</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_ad2538618676a072e7b80778df97e3341"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#ad2538618676a072e7b80778df97e3341">ESP32CPP::GPIO::writeByte</a></div><div class="ttdeci">static void writeByte(gpio_num_t pins[], uint8_t value, int bits)</div><div class="ttdoc">Write up to 8 bits of data to a set of pins.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:195</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_adf4319c3ae87b69012c0c4696dc69081"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#adf4319c3ae87b69012c0c4696dc69081">ESP32CPP::GPIO::addISRHandler</a></div><div class="ttdeci">static void addISRHandler(gpio_num_t pin, gpio_isr_t handler, void *pArgs)</div><div class="ttdoc">Add an ISR handler to the pin.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:25</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_a9c168a825e68fa07f9d707c5832230f0"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#a9c168a825e68fa07f9d707c5832230f0">ESP32CPP::GPIO::high</a></div><div class="ttdeci">static void high(gpio_num_t pin)</div><div class="ttdoc">Set the pin high.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:57</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_a977756d253f25761e2412d8c191fe7da"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#a977756d253f25761e2412d8c191fe7da">ESP32CPP::GPIO::interruptDisable</a></div><div class="ttdeci">static void interruptDisable(gpio_num_t pin)</div><div class="ttdoc">Disable interrupts on the named pin.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:78</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_afd43e7bc27885215900f7780197a0247"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#afd43e7bc27885215900f7780197a0247">ESP32CPP::GPIO::setInput</a></div><div class="ttdeci">static void setInput(gpio_num_t pin)</div><div class="ttdoc">Set the pin as input.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:131</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_add68250ce86665c502405a353ef1c870"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#add68250ce86665c502405a353ef1c870">ESP32CPP::GPIO::read</a></div><div class="ttdeci">static bool read(gpio_num_t pin)</div><div class="ttdoc">Read a value from the given pin.</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:119</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html">ESP32CPP::GPIO</a></div><div class="ttdoc">Interface to GPIO functions.</div><div class="ttdef"><b>Definition:</b> GPIO.h:31</div></div>
<div class="ttc" id="classESP32CPP_1_1GPIO_html_ae715e46a8c6d0ba0ebe3d15de9cc7db0"><div class="ttname"><a href="classESP32CPP_1_1GPIO.html#ae715e46a8c6d0ba0ebe3d15de9cc7db0">ESP32CPP::GPIO::inRange</a></div><div class="ttdeci">static bool inRange(gpio_num_t pin)</div><div class="ttdoc">Determine if the pin is a valid pin for an ESP32 (i.e. is it in range).</div><div class="ttdef"><b>Definition:</b> GPIO.cpp:68</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
